
#include <viz_types.h>

int	    getFixSums();
const char  *getPort();
const char  *getServer();

void	loop();
void	newChannel(void*,int (*callback)(void*),void*);

int	gpsInput();
void	gpsCharInput(uint8_t);
void	*gpsSocket();
void	gpsOutput(const char *);
void	gpsLoadTrackFile(const char *);

double	lastLon();
double	lastLat();
double	lastStamp();
void	paintLastFix();
void	localFrame(double,double,double *,double *,double *);
void	paintFix(const uint8_t*,double,double,double);
int	parseNMEAAngle(const uint8_t*,const uint8_t*,double*);
int	sphereIntersect(double*,double*,double,double*,double*);
void	paintFixCoords(const uint8_t *,double,double,double,double);
void	paintSquare(double,double,double,double);
void	paintSquareInfo(double,double,double,double,double,double);
void	newGGA(const uint8_t*,const uint8_t*,const uint8_t*);
void	newFix(const uint8_t*,const uint8_t*,const uint8_t*,const uint8_t*,const uint8_t*);
void	paintGreatcircle(double,double,double,double,int,double*,double*);
void	toggleAutomap();
void	paintAuxInfo();

void	paintSatellites();
void	newSolution(const uint8_t [][81],int);
void	newSatelliteFix(
	    const uint8_t*,
	    const uint8_t*,
	    const uint8_t*,
	    const uint8_t*
	);

void	flush();
void	*eventSocket();
int	windowWidth();
int	windowHeight();
int	windowInput();
int	getHelpState();
int	getDisplayMode();
int	getInteractionState();
int	getFiltering();
int	getMapMode();
#ifdef macosx
void	osxLoop();
#endif

void	trsp44(double *);
void	apply44To3(double*,const double*,const double*);
void	apply44To3v(double*,const double*,const double*);
void	rot44(double*,const double*,const double*,double);

void	paintSphere();
int	getSubdivision();
void	setSubdivision(int);

void	paint();
void	trash();

void	loadMap();

void	getHTTPMap(int =1,double =0,double =0,double =0);
void	zoomHTTPMap(int);
void	paintMapSquare();
void	getMapSquare(
	    double*,
	    double*,
	    double*,
	    double*
	);


void	getHTTPBrushData();

void	resample(
	    uint8_t	*,
	    uint32_t	,
	    uint32_t	,
	    uint8_t	*,
	    uint32_t	,
	    uint32_t
	);

void	paintPatches();
int	isInMapSquare(double,double);
void	setMapSquare(double,double,double,double);
void	makePatch(
	    double	,
	    double	,
	    double	,
	    double	,
	    uint8_t	*,
	    uint32_t	,
	    uint32_t
	);

void	*newGif(void*,double,double,double,double,int);
int	gifHandler(void*);

void	setView();
void	resetView();
void	saveView();
void	zoom(double);
void	paintCamera();
void	pan(double,double);
void	tumble(double,double);
void	centerViewOnFix(double,double);
void	getEye(double*);
void	getEyePickLine(
	    double *_eye,
	    double *_dir,
	    double x,
	    double y
	);

void	paintTrack();
void	newTrackFix(
	    const uint8_t*,
	    const uint8_t*,
	    const uint8_t*,
	    const uint8_t*
	);

void	paintWaypoints();
void	newWaypoint(
	    const uint8_t *,
	    const uint8_t *,
	    const uint8_t *,
	    const uint8_t *,
	    const uint8_t *,
	    const uint8_t *,
	    const uint8_t *,
	    const uint8_t *,
	    const uint8_t *
	);

int	fontHeight();
void	paintString(const uint8_t *);
void	stringBBox(const uint8_t *,double *);

void	paintHelp();

void	paintPick();
int	pick(int,int);
double	lastPickLat();
double	lastPickLon();
void	startArea(int,int);
void	moveArea(int,int);
void	endArea(int,int);

void	onWindowSize(int,int);
void	onWindowDamage();
void	onWindowClose();
void	onButtonDown(int,int,int,int,int,int);
void	onMouseMove(int,int);
void	onButtonUp(int,int,int);
void	onKeyDown(int,int,int,int,int,int);

