
#include <viz_app.h>
#include <viz_system.h>

class BrushData
{
public:
    void    *socket;
    int	    stream(uint8_t*,int);
    void    finish();
};

int BrushData::stream(
uint8_t *buffer,
int	size
)
{
    while(size--)
    {
	uint8_t c= *(buffer++);
	gpsCharInput(c);
    }
    return 0;
}

void BrushData::finish()
{
}

static int brushDataHandler(
void *data
)
{
    BrushData *brush= (BrushData*)data;
    while(1)
    {
	uint8_t buffer[16384];
	int r= system::readSocket(
	    brush->socket,
	    buffer,
	    16384
	);

	if(r>0 && brush->stream(buffer,r)<0)			r= -1;
	else if(r<0 && system::lastError()==system::eAgain)	break;
	else if(r<0 && system::lastError()==system::eInterrupt)	continue;

	if(r<=0)
	{
	    brush->finish();
	    delete brush;
	    return -1;
	}
    }
    return 0;
}

void getHTTPBrushData()
{
    char url[1024];
    double la= lastPickLat();
    double lo= lastPickLon();

    double la0;
    double lo0;
    double la1;
    double lo1;
    getMapSquare(&la0,&lo0,&la1,&lo1);

    system::sprintf(	
	url,
	"/db/search.cgi?query=&DLatitude=%.5f&DLongitude=%.5f&LaNS=N&NMEALat=&LoEW=E&NMEALong=&range=%d&results=all&format=PMGNWPL",
	la,
	lo,
	1000
    );

    void *socket= system::makeSocket("www.gpster.net",80);
    if(socket==(void*)-1) return;

    char buffer[2048];
    system::sprintf(
	buffer,
	"GET %s HTTP/1.0\r\n"
	"Connection: Keep-Alive\r\n"
	"User-Agent: GPS3d (http://www.mgix.com/gps3d)\r\n"
	"Accept: */*\r\n"
	"Host: www.gpster.net:80\r\n"
	"\r\n",
	url
    );

    char *p= buffer;
    int n= system::strlen(buffer);
    while(n>0)
    {
	int r= system::writeSocket(
	    socket,
	    p,
	    n
	);
	if(r>0)								{ n-= r; p+= r; }
	else if(r==0 && system::lastError()==system::eNone)		continue;
	else if(r< 0 && system::lastError()==system::eAgain)		continue;
	else if(r< 0 && system::lastError()==system::eInterrupt)	continue;
	else
	{
	    system::closeSocket(socket);
	    return;
	}
    }

    BrushData *data= new BrushData;
    data->socket= socket;
    newChannel(socket,brushDataHandler,data);
}

