
#include <viz_app.h>
#include <viz_gl.h>

static void paintLine(
const	char	*s,
	double	*y
)
{
    *y-= (double)fontHeight();
    glRasterPos3d(10.0,*y,0.0);
    paintString((const uint8_t*)s);
}

void paintHelp()
{
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	    glLoadIdentity();
	    glOrtho(
		0.0, (double)windowWidth(),
		0.0, (double)windowHeight(),
		-1000.0, 1000.0
	    );
	
	    if(getHelpState())
	    {
		double yPos= windowHeight()-30;
		glColor3ub(0xFF,0xFF,0xFF);
		paintLine("H - Turn on screen help on/off",		&yPos);
		paintLine("",						&yPos);
		paintLine("Mouse button - Orbit",			&yPos);
		paintLine("Shift + Mouse button - Select great circle",	&yPos);
		paintLine("Ctrl + Mouse button - Zoom",			&yPos);
		paintLine("Ctrl+ Shift + Mouse button - Pan",		&yPos);
		paintLine("",						&yPos);
		paintLine("R/Home - Reset to default view",		&yPos);
		paintLine("C - Center view on current fix",		&yPos);
		paintLine("P - Center view on picked fix",		&yPos);
		paintLine("+ - Zoom in",				&yPos);
		paintLine("- - Zoom out",				&yPos);
		paintLine("Tab - Switch sphere display mode",		&yPos);
		paintLine("< - Decrease sphere precision",		&yPos);
		paintLine("> - Decrease sphere precision",		&yPos);
		paintLine("F - Toggle texture filtering",		&yPos);
		paintLine("Escape/Q - Exit",				&yPos);
		paintLine("",						&yPos);
		paintLine("T - Load track record from GPS",		&yPos);
		paintLine("W - Load waypoints from GPS",		&yPos);
		paintLine("L - Load GPS session from file",		&yPos);
		paintLine("M - Map brush On/Off",			&yPos);
		paintLine("Z - Decrease map brush size ",		&yPos);
		paintLine("X - Increase map brush size",		&yPos);
		paintLine("A - Automap On/Off",				&yPos);
		paintLine("Enter - Grab map inside brush",		&yPos);
		paintLine("G - Grab GPS data fron gpster",		&yPos);
	    }
	    else
	    {
		double yPos= windowHeight()-10;
		glColor3ub(0xFF,0xFF,0xFF);
		paintLine("Press H to toggle on screen help",	&yPos);
	    }
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();
}

