
#include <viz_app.h>
#include <viz_system.h>

class AsyncChannel
{
public:

    static	AsyncChannel	*all;
    static	int		nChannels;
    typedef	int		(*Callback)(void*);

				AsyncChannel(void*,Callback,void*);
				~AsyncChannel();

		void		*socket;
		Callback	callback;
		void		*data;
		AsyncChannel	*prev;
		AsyncChannel	*next;

};

int AsyncChannel::nChannels;
AsyncChannel *AsyncChannel::all;

AsyncChannel::AsyncChannel(
void		*s,
Callback	f,
void		*d
)
{
    socket= s;
    callback= f;
    data= d;

    prev= 0;
    next= all;
    all= this;
    if(next) next->prev= this;
    ++nChannels;
}

AsyncChannel::~AsyncChannel()
{
    system::closeSocket(socket);

    if(next) next->prev= prev;
    if(prev) prev->next= next;
    else all= next;
    --nChannels;
}

void loop()
{
    new AsyncChannel(gpsSocket(),(AsyncChannel::Callback)gpsInput,0);
    new AsyncChannel(eventSocket(),(AsyncChannel::Callback)windowInput,0);

    void **sockets= 0;
    int socketLength= 0;
    while(1)
    {
	if(socketLength<AsyncChannel::nChannels)
	{
	    sockets= (void**)system::realloc(sockets,AsyncChannel::nChannels*sizeof(void*));
	    socketLength= AsyncChannel::nChannels;
	}

	void **s= sockets;
	AsyncChannel *c= AsyncChannel::all;
	while(c)
	{
	    *(s++)= c->socket;
	    c= c->next;
	}

	void *ret= system::waitOn(
	    AsyncChannel::nChannels,
	    sockets
	);

	c= AsyncChannel::all;
	while(c)
	{
	    if(ret==c->socket)
	    {
		int r= (*c->callback)(c->data);
		if(r<0) delete c;
		break;
	    }
	    c= c->next;
	}

	paint();
    }
}

void newChannel(
void	*socket,
int	(*callback)(void*),
void	*data
)
{
    new AsyncChannel(
	socket,
	callback,
	data
    );
}

