
#include <viz_app.h>
#include <viz_system.h>

#ifdef macosx
#include <pthread.h>
#include <Carbon/Carbon.h>
#endif

int fixSums= 0;
const char *port= 0;
const char *server= 0;

int	    getFixSums()    { return fixSums;	}
const char  *getPort()	    { return port;	}
const char  *getServer()    { return server;	}

int main(
	int	argc,
const	char	**argv
)
{
#ifdef macosx
    CFBundleRef bndl= CFBundleGetMainBundle();
    if(bndl)
    {
       CFURLRef url= CFBundleCopyBundleURL(bndl);
        if(url)
        {
            CFStringRef path= CFURLCopyFileSystemPath(url,kCFURLPOSIXPathStyle);
            if(path)
            {
                char buf1[4097];
                char buf2[4097];
                int bufSize= 4096;
                CFStringGetCString(
                    path,
                    buf1,
                    bufSize,
                    CFStringGetSystemEncoding()
                );
                CFRelease(path);
                
                system::sprintf(
                    buf2,
                    "%s/Contents/Resources",
                    buf1
                );
                system::chdir(buf2);
            }
            CFRelease(url);
        }
    }
#endif

    while(1)
    {
	const char *arg= *++argv;
	if(arg==0) break;
	else if(arg[0]!='-')
	{
	    if(arg[0]==0)	system::error(1,"error: invalid command line\n");
	    else if(server==0)	server= arg;
	    else if(port==0)	port= arg;
	    else		system::error(1,"error: too many arguments\n");
	}
	else
	{
	    int c= arg[1];
	    if(c=='i')		fixSums= 1;
	    else		system::error(0,"error: unknown switch -%c\n",c);
	}
    }

    if(port==0)	    port="";
    if(server==0)   server= "127.0.0.1";

    system::error(0,"GPS3D V1.20 - viz - Please do not use for navigation.\n");
#ifndef macosx
    loop();
#else
    pthread_t t;
    eventSocket();
    pthread_create(&t,0,(void *(*)(void*))loop,0);
    osxLoop();
#endif

    return 0;
}

