
#include <viz_app.h>
#include <viz_gl.h>

static double	la;
static double	lo;

double lastPickLat()	{ return la;	}
double lastPickLon()	{ return lo;	}

int pick(
int x,
int y
)
{
    int ok= -1;
    double eye[3];
    double dir[3];
    getEyePickLine(
	eye,
	dir,
	x,
	windowHeight()-y-1
    );

    double pick[3];
    if(sphereIntersect(0,pick,1.0,eye,dir))
    {
	la= system::asin(pick[1]);
	lo= system::atan2(pick[0],pick[2]);
	la*= (180.0/system::pi());
	lo*= (180.0/system::pi());
	trash();
	ok= 0;
    }
    return ok;
}

static int square= 0;
static double la0;
static double lo0;
static double la1;
static double lo1;

void	startArea(
int	x,
int	y
)
{
    if(pick(x,y)>=0)
    {
	la0= la;
	lo0= lo;
	square= 2;
	trash();
    }
}

void	moveArea(
int	x,
int	y
)
{
    if(pick(x,y)>=0)
    {
	la1= la;
	lo1= lo;
	trash();
    }
}

void	endArea(
int,
int
)
{
    square= 1;
    trash();
}

void paintPick()
{
    if(square<2)
    {
	glColor3ub(0x00,0xFF,0x00);
	paintFix(0,la,lo,1.0/32.0);
    }

    if(square)
    {
	glColor3ub(0xFF,0xFF,0x00);
	paintSquare(la0,lo0,la1,lo1);
	paintSquareInfo(300.0,37.0,la0,lo0,la1,lo1);
    }

    glColor3ub(0x00,0x00,0xFF);
    paintFixCoords((const uint8_t*)"Picked fix",150.0,37.0,la,lo);
}

