
#include <viz_app.h>
#include <viz_gl.h>
#include <viz_system.h>

static int stored;
static int allocated;
double *track;

void paintTrack()
{
    int n= stored;
    if(n)
    {
	double *p= track;
	glColor3ub(0x00,0xFF,0x00);
	glBegin(GL_LINE_STRIP);
	    while(n--)
	    {
		glVertex3dv(p);
		p+= 3;
	    }
	glEnd();
    }
}

void newTrackFix(
const uint8_t *latitude,
const uint8_t *latitudeSign,
const uint8_t *longitude,
const uint8_t *longitudeSign
)
{
    double la;
    double lo;
    if(parseNMEAAngle(latitude,latitudeSign,&la)<0) return;
    if(parseNMEAAngle(longitude,longitudeSign,&lo)<0) return;

    double rla= la*system::pi()/180.0;
    double cla= system::cos(rla);
    double sla= system::sin(rla);

    double rlo= lo*system::pi()/180.0;
    double clo= system::cos(rlo);
    double slo= system::sin(rlo);

    double x= cla*slo;
    double y= sla;
    double z= cla*clo;

    if(stored>=allocated)
    {
	allocated+= 1000;
	track= (double*)system::realloc(track,allocated*3*sizeof(double));
    }

    track[3*stored+0]= x;
    track[3*stored+1]= y;
    track[3*stored+2]= z;
    ++stored;

    trash();
}

