

#include <viz_app.h>
#include <viz_gl.h>
#include <viz_system.h>

class Waypoint
{
public:
	uint8_t	*name;
	double	la;
	double	lo;
};

static int nPoints= 0;
static int available= 0;
static Waypoint *waypoints;

void newWaypoint(
const uint8_t *latitude,
const uint8_t *latitudeSign,
const uint8_t *longitude,
const uint8_t *longitudeSign,
const uint8_t *,
const uint8_t *,
const uint8_t *name,
const uint8_t *,
const uint8_t *
)
{
    double la;
    double lo;
    if(parseNMEAAngle(latitude,latitudeSign,&la)<0) return;
    if(parseNMEAAngle(longitude,longitudeSign,&lo)<0) return;

    if(nPoints>=available)
    {
	available= 2*nPoints+10;
	waypoints= (Waypoint*)system::realloc(waypoints,available*sizeof(Waypoint));
    }
    
    Waypoint *pnt= waypoints+(nPoints++);
    pnt->name= (uint8_t*)system::strdup((const char*)name);
    pnt->la= la;
    pnt->lo= lo;

    trash();
}

void paintWaypoints()
{
    int n= nPoints;
    Waypoint *p= waypoints;
    glColor3ub(0xFF,0x10,0x10);
    while(n--)
    {
	paintFix(p->name,p->la,p->lo,1.0/16384.0);
	++p;
    }
}

